##
##  assemblyscript.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2024 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_assemblyscript      0.27.27
%define       V_assemblyscript_snap 20240412

#   package information
Name:         assemblyscript
Summary:      AssemblyScript Programming Language
URL:          https://www.assemblyscript.org/
Vendor:       The AssemblyScript Project
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      Apache
Version:      %{V_assemblyscript}
Release:      20240412

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/assemblyscript/assemblyscript-%{V_assemblyscript}-%{V_assemblyscript_snap}.tar.gz
Source1:      asc.sh
Source2:      asinit.sh

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, node-openpkg
PreReq:       OpenPKG, openpkg >= 20160101, node, binaryen

%description
    AssemblyScript targets WebAssembly's feature set specifically,
    giving developers low-level control over their code.

%track
    prog assemblyscript:release = {
        version   = %{V_assemblyscript}
        url       = https://github.com/AssemblyScript/assemblyscript/releases
        regex     = tree/v(\d+\.\d+\.\d+)
    }
    prog assemblyscript:snapshot = {
        version   = %{V_assemblyscript}-%{V_assemblyscript_snap}
        url       = http://download.openpkg.org/components/versioned/assemblyscript/
        regex     = assemblyscript-(__VER__)\.tar\.gz
    }

%prep
    %setup -q -c

%build
    %{l_prefix}/bin/node-openpkg squeeze -n "default:safe"

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/lib/assemblyscript
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE asc.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/asc
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE asinit.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/asinit
    %{l_prefix}/bin/node-openpkg install \
        %{l_prefix}/lib/assemblyscript/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

